
This directory provides support for generating the local.inc file
automatically with no editing of the resultant file in almost all
cases.


For those not wanting to read any further, you can try it out by 

	./configure --with-domain-name=`hostname | cut -d. -f 2,3` --with-sys-upload-dir=/tmp

( the upload directory needs to exist, be writeable and not be
inside the www directory, /tmp is probably not what you want :-)


You can compare the output file to that not using autoconf using :-

	diff -u ../../etc/local.inc local.inc

In addition to generating a local.inc, this also generates a file
containing sample Apache vhost directives.



********************************************************************

    No files will be installed, it is the responsibility of the
    administrator/packager to copy the output files into their
    correct locations.

********************************************************************


Status
======


The configuration support is currently in "contrib" because it does
not yet provide enough features for those wanting to build pacakges
to make it worthwhile them switching. In particular those using Debian
should continue to use the Debian build/configuration tools, since they
have more features and are integrated into the OS.

However, if you are curerntly using CVS or installing GForge
yourself, then this should prove helpful, if not I'd like to know
what you want changed.


GFORGE Configuration HOWTO.
===========================

The support for configuration of GForge is new and has not been
fully tested on all possible configurations. The files that it uses
for inputs and outputs are in this direcotry, so using ./configure
will not damage the settings of an existing system.


The current configuration implementation has been designed to be
both flexible and easy to use. You can list the full set of
configrable options by typing :-

  % ./configure --help

At the time of writing this document, the full list of options are :-

Optional Features:
  --disable-FEATURE       do not include FEATURE (same as --enable-FEATURE=no)
  --enable-FEATURE[=ARG]  include FEATURE [ARG=yes]
  --enable-defaults=TYPE  enable TYPE specific defaults (None)
  --enable-ldap           enable LDAP (no)
  --enable-jabber         enable Jabber (no)

Optional Packages:
  --with-PACKAGE[=ARG]    use PACKAGE [ARG=yes]
  --without-PACKAGE       do not use PACKAGE (same as --with-PACKAGE=no)
  --with-domain-name      the default domain (company.com)
  --with-sys-default-domain
                          the gforge server (gforge.DOMAIN-NAME)
  --with-sys-fallback-domain
                          the gforge fallback server (gforge2.DOMAIN-NAME)
  --with-sys-internal-network
                          netmask of internal network (192.168.1.)
  --with-sys-cvs-host     the CVS server (cvs.DOMAIN-NAME)
  --with-project-cvs-hosts
                          run an individual CVS server per project (a single
                          CVS server for the entire site)
  --with-sys-download-host
                          the download server (download.DOMAIN-NAME)
  --with-sys-upload-host  the upload server (upload.DOMAIN-NAME)
  --with-sys-shell-host   the shell server (shell.DOMAIN-NAME)
  --with-sys-users-host   the users server (users.DOMAIN-NAME)
  --with-sys-docs-host    the docs server (docs.DOMAIN-NAME)
  --with-sys-lists-host   the lists server (lists.DOMAIN-NAME)
  --with-sys-dns1-host    the primary nameserver (ns1.DOMAIN-NAME)
  --with-sys-dns2-host    the secondary nameserver (ns2.DOMAIN-NAME)
  --with-sys-dbhost       the DB server (localhost)
  --with-sys-dbreadhost   the readonly DB server (localhost)
  --with-sys-dbreaddb     databases that are read only (stats)
  --with-sys-dbname       name of database (alexandria)
  --with-sys-dbuser       user to access DB as (www)
  --with-sys-dbpasswd     use password to access DB
  --with-sys-ldap-host    LDAP server (ldap.DOMAIN-NAME)
  --with-sys-ldap-base-dn LDAP base dn (dc=DOMAIN-NAME)
  --with-sys-ldap-bind-dn LDAP bind dn (cn=SF_robot,$LDAP_BASE_DN)
  --with-sys-ldap-admin-dn
                          LDAP admin dn ($LDAP_ADMIN_DN)
  --with-sys-ldap-password
                          LDAP password
  --with-sys-jabber-host  Jabber server (jabber.DOMAIN-NAME)
  --with-sys-jabber-user  Jabber messages come from USER (noreply)
  --with-sys-jabber-pass  JABBER password (temp123)
  --with-sys-path-to-jpgraph
                          path to Jpgraph
  --with-sys-upload-dir   location of upload, must be outside of DocumentRoot
  --with-homedir-prefix   homedir prefix ($HOME_DIR)
  --with-groupdir-prefix  groups prefix ($GROUP_DIR)
  --with-cgi-dir          directory for CGIs
  --with-ftpincoming-dir  directory for a users incoming files
  --with-db=DB            DB to use (only pgsql currently supported)
  --with-scm=SCM          SCM system to use (only CVS currently supported)
  --with-sys-name         the name of the GForge installation (prodigy)
  --with-sys-news-group   the group id for news (3)
  --with-sys-stats-group  the group id for stats (2)
  --with-sys-peer-rating-group
                          the group id for peer ratings (4)
  --with-default-trove-cat
                          the default Trove category (18)
  --with-sys-theme        Theme to use by default (gforge)
  --with-sys-lang         language to use (English)
  --with-sys-session-key  the session key (generate one using ps)


As a first pass, you will want to set the default domain
(--with-domain-name) and the uploads directory (--with-sys-upload-dir).

Since the number of options is quite large, a facility has been
provided to provide configurable defaults (--enable-defaults=TYPE).
TYPE can be a built-in set of defaults (there is an early attempt
at generating Debian specific defaults, although these would probably
be useful for any FHS compliant system), or it can be an absolute
pathname to a file in Bourne shell syntax that will be sourced and
used to provide the defaults, for example :-

	./configure --enable-defaults=`pwd`/mysite.config

And ./mysite.config could contain

domain_name=mysite.com

Obviously for a single line this isn't worth it, but if you find
yourself having to pass lots of options to configure gforge exactly as
you want, you may want to use a defaults file.

If you are a Linux distribution or OS vendor, I will take changes to add
your defaults to the set of built-ins.


Future Plans
============

There is an intention to adapt the infrastructure to support user
contributed patches and plugins that require configuration before
use. 

There has been some discussion on this, but it is still a
work-on-the-back-of-an-envelop.



richard.
-- 
$Id: README.configure,v 1.1 2003/02/01 23:31:20 offer Exp $
